package com.hikcreate.drv_photo_pic.impl;


import com.hikcreate.entity.PicResult;
import oracle.sql.BLOB;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.client.Get;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.Table;
import org.apache.hadoop.hbase.util.Bytes;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.*;

public class SqlHelp {

    private static Logger logger = LoggerFactory.getLogger(SqlHelp.class);

    public static String getStartTime(String sql, String url, String username, String password) {
        String startTime = null;
        try {
            Class.forName("oracle.jdbc.OracleDriver");
            Connection connection1 = DriverManager.getConnection(url, username, password);
            PreparedStatement pstm1 = connection1.prepareStatement(sql);
            ResultSet resultSet1 = pstm1.executeQuery();
            while (resultSet1.next()) {
                startTime = resultSet1.getString("MTIME").substring(0, 10);
            }
            resultSet1.close();
            pstm1.close();
            connection1.close();
            return startTime;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }


    public static PicResult getFlag(String rowkey, Table table, String[] colValue, String gxsj) {
        //1:写入,2:删除原有并写入，0：不写入
        int flag1 = 1;
        String url = "";
        PicResult picResult = new PicResult();
        try {
            Get get = new Get(rowkey.getBytes());
            get.addColumn("info".getBytes(), "picUrl".getBytes());
            get.addColumn("info".getBytes(), "gxsj".getBytes());
            Result result = table.get(get);
            if(result.size()>0){
                for (Cell cell : result.rawCells()) {
                    String colName = Bytes.toString(cell.getQualifierArray(), cell.getQualifierOffset(), cell.getQualifierLength());
                    String value = Bytes.toString(cell.getValueArray(), cell.getValueOffset(), cell.getValueLength());
                    if ("picUrl".equals(colName)) {
                        colValue[0] = value;
                    }
                    if ("gxsj".equals(colName)) {
                        colValue[1] = value;
                    }
                }
                if (colValue[0] == null) {
                    flag1 = 1;
                } else if (colValue[0] != null && (gxsj.substring(0, 19).compareTo(colValue[1].substring(0, 19)) < 0)) {
                    flag1 = 0;
                } else {
                    flag1 = 2;
                    url = colValue[0];
                }
                picResult.setI(flag1);
                picResult.setUrl(url);
                return picResult;
            }else {
                picResult.setI(flag1);
                picResult.setUrl(url);
                return picResult;
            }
        } catch (IOException e) {
            e.printStackTrace();
            picResult.setI(0);
            picResult.setUrl(url);
            return picResult;
        }
    }

    public synchronized static byte[] blobToByteZp(BLOB zp) {
        try {
            long length = zp.length();
            byte[] bytes = new byte[(int) length];
            InputStream input = zp.getBinaryStream();
            input.read(bytes, 0, (int) length);
            byte[] bytes1 = blobToBytes(zp);
            return bytes1;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static byte[] blobToBytes(Blob blob) {
        BufferedInputStream is = null;
        try {
            is = new BufferedInputStream(blob.getBinaryStream());
            byte[] bytes = new byte[(int) blob.length()];
            int len = bytes.length;
            int offset = 0;
            int read = 0;
            while (offset < len
                    && (read = is.read(bytes, offset, len - offset)) >= 0) {
                offset += read;
            }
            return bytes;
        } catch (Exception e) {
            return null;
        } finally {
            try {
                is.close();
                is = null;
            } catch (IOException e) {
                return null;
            }
        }
    }
}
