package com.hikcreate.drv_photo_pic.impl;


import com.hikcreate.drv_photo_pic.VioPic;
import com.hikcreate.entity.PicByte;
import com.hikcreate.service.fdfs.service.FileService;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.KeyValue;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.util.Bytes;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.sql.*;
import java.sql.Connection;
import java.util.Map;

@Service("vioPicImpl")
public class VioPicImpl implements VioPic {

    private static Logger logger = LoggerFactory.getLogger(VioPicImpl.class);

    @Value("${hive.url}")
    private String hiveUrl;
    @Value("${hive.user}")
    private String hiveUser;
    @Value("${hive.password}")
    private String hivePassWord;
    @Value("${increment.vio.pic.sql}")
    private String incrementVioPicSql;
    @Value("${hbase.zookeeper.property.clientPort}")
    private String hbaseAddress;
    @Value("${hbase.zookeeper.quorum}")
    private String hbaseZkQuorum;
    @Value("${hbase.master}")
    private String hbaseMaster;
    @Value("${hbase.vio.table}")
    private String vioTableStr;
    @Value("${ftpUrl}")
    private String ftpUrl;
    @Value("${httpUrl}")
    private String httpUrl;
    @Value("${vio.pic.sql.byrow}")
    private String sqlByRow;

    @Autowired
    private FileService fileService;

    private String rowkey;
    private static TableName vioTableName;
    private static Table vioTable;
    private static Configuration hbaseConf;
    private static org.apache.hadoop.hbase.client.Connection hbaseConn;
    private static boolean isPut = false;

    private static String hphm;
    private static String hpzl;
    private static String wfsj;
    private static String wfxw;
    private static String url1;
    private static String url2;
    private static String url3;
    private static Put put;
    private static MultiValueMap<String, String> params;
    private static HttpEntity<MultiValueMap<String, String>> requestEntity;
    private static HttpHeaders headers;
    private static HttpMethod method;
    private static RestTemplate restTemplate;
    private static String[] colValue;

    /**
     * 增量同步违法图片
     */
    @Override
    public synchronized void getIncrementVioPic(String startDay, String endDay) {
        try {
            String JDBC_DRIVER = "org.apache.hive.jdbc.HiveDriver";
            Class.forName(JDBC_DRIVER);
            Connection connection = DriverManager.getConnection(hiveUrl, hiveUser, hivePassWord);
            PreparedStatement pstm = connection.prepareStatement(incrementVioPicSql);
            pstm.setString(1, endDay);
            pstm.setString(2, startDay);
            ResultSet resultSet = pstm.executeQuery();
            hbaseConf = HBaseConfiguration.create();
            hbaseConf.set("hbase.zookeeper.property.clientPort", hbaseAddress);
            hbaseConf.set("hbase.zookeeper.quorum", hbaseZkQuorum);
            hbaseConn = ConnectionFactory.createConnection(hbaseConf);
            vioTableName = TableName.valueOf(vioTableStr);
            vioTable = hbaseConn.getTable(vioTableName);
            restTemplate = new RestTemplate();
            headers = new HttpHeaders();
            method = HttpMethod.POST;
            headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
            long count = 0L;
            loop1:
            while (resultSet.next()) {
                count = count + 1;
                logger.info("数据库查询出东西了------------" + count);
                hphm = resultSet.getString("hphm");
                hpzl = resultSet.getString("hpzl");
                wfsj = resultSet.getString("wfsj");
                wfxw = resultSet.getString("wfxw");
                url1 = resultSet.getString("url1");
                url2 = resultSet.getString("url2");
                url3 = resultSet.getString("url3");
                rowkey = hphm == null ? "null" : hphm + "#" +
                        hpzl == null ? "null" : hpzl + "#" +
                        wfsj == null ? "null" : wfsj.substring(0, 19) + "#" +
                        wfxw == null ? "wfxw" : wfxw;
                Get get = new Get(rowkey.getBytes());
                put = new Put(rowkey.getBytes());
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl1"));
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl2"));
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl3"));
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl4"));
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl5"));
                get.addColumn(Bytes.toBytes("info"), Bytes.toBytes("ftpUrl6"));
                Result result = vioTable.get(get);
                colValue = new String[6];
                for (Cell cell : result.rawCells()) {
                    String colName = Bytes.toString(cell.getQualifierArray(), cell.getQualifierOffset(), cell.getQualifierLength());
                    String value = Bytes.toString(cell.getValueArray(), cell.getValueOffset(), cell.getValueLength());
                    //保存值
                    switch (colName) {
                        case "ftpUrl1":
                            colValue[0] = value;
                        case "ftpUrl2":
                            colValue[1] = value;
                        case "ftpUrl3":
                            colValue[2] = value;
                        case "ftpUrl4":
                            colValue[3] = value;
                        case "ftpUrl5":
                            colValue[4] = value;
                        case "ftpUrl6":
                            colValue[5] = value;
                    }
                }
//                logger.info("查询get结果:" + colValue.toString());
                //插入数据操作
                //url1
                if (url1 != null && !"".equals(url1)) {
                    //判断之前是否已经插入过图片了，防止多次插入
                    if (url1.equals(colValue[0]) || url1.equals(colValue[3])) {
                        logger.info("url1已经插入过了");
                        continue loop1;
                    }
                    if (colValue[0] == null || "".equals(colValue[0])) {
                        //url1插入ftpurl1
                        if (url1.startsWith("ftp")) {
                            //ftp协议
                            putData("ftpUrl1", "fastDfsUrl1", url1, ftpUrl, fileService);
                        } else if (url1.startsWith("http")) {
                            //http协议
                            putData("ftpUrl1", "fastDfsUrl1", url1, httpUrl, fileService);
                        }
                    } else {
                        if (colValue[3] == null || "".equals(colValue[3])) {
                            //url1插入ftpurl4
                            if (url1.startsWith("ftp")) {
                                putData("ftpUrl4", "fastDfsUrl4", url1, ftpUrl, fileService);
                            } else if (url1.startsWith("http")) {
                                putData("ftpUrl4", "fastDfsUrl4", url1, httpUrl, fileService);
                            }
                        }
                    }
                }
                if (url2 != null && !"".equals(url2)) {
                    if (url2.equals(colValue[1]) || url2.equals(colValue[4])) {
                        logger.info("url2已经插入过了");
                        continue loop1;
                    }
                    if (colValue[1] == null || "".equals(colValue[1])) {
                        //url1插入ftpurl1
                        if (url2.startsWith("ftp")) {
                            putData("ftpUrl2", "fastDfsUrl2", url2, ftpUrl, fileService);
                        } else if (url2.startsWith("http")) {
                            putData("ftpUrl2", "fastDfsUrl2", url2, httpUrl, fileService);
                        }
                    } else {
                        if (colValue[4] == null || "".equals(colValue[4])) {
                            //url1插入ftpurl4
                            if (url2.startsWith("ftp")) {
                                putData("ftpUrl5", "fastDfsUrl5", url2, ftpUrl, fileService);
                            } else if (url2.startsWith("http")) {
                                putData("ftpUrl5", "fastDfsUrl5", url2, httpUrl, fileService);
                            }
                        }
                    }
                }
                if (url3 != null && !"".equals(url3)) {
                    if (url3.equals(colValue[2]) || url3.equals(colValue[5])) {
                        logger.info("url3已经插入过了");
                        continue loop1;
                    }
                    if (colValue[2] == null || "".equals(colValue[2])) {
                        //url1插入ftpurl1
                        if (url3.startsWith("ftp")) {
                            putData("ftpUrl3", "fastDfsUrl3", url3, ftpUrl, fileService);
                        } else if (url3.startsWith("http")) {
                            putData("ftpUrl3", "fastDfsUrl3", url3, httpUrl, fileService);
                        }
                    } else {
                        if (colValue[5] == null || "".equals(colValue[5])) {
                            //url1插入ftpurl4
                            if (url3.startsWith("ftp")) {
                                putData("ftpUrl6", "fastDfsUrl6", url3, ftpUrl, fileService);
                            } else if (url3.startsWith("http")) {
                                putData("ftpUrl6", "fastDfsUrl6", url3, httpUrl, fileService);
                            }
                        }
                    }
                }
                if (isPut) {
                    vioTable.put(put);
                    isPut = false;
                }
            }
            resultSet.close();
            pstm.close();
            connection.close();
            logger.info("执行完毕：---------------------");
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (vioTable != null) {
                try {
                    vioTable.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (hbaseConn != null) {
                try {
                    hbaseConn.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    /**
     * 删除所有图片
     */
    @Override
    public void delAllVioPic() {
        hbaseConf = HBaseConfiguration.create();
        hbaseConf.set("hbase.zookeeper.property.clientPort", hbaseAddress);
        hbaseConf.set("hbase.zookeeper.quorum", hbaseZkQuorum);
        try {
            hbaseConn = ConnectionFactory.createConnection(hbaseConf);
            vioTableName = TableName.valueOf(vioTableStr);
            vioTable = hbaseConn.getTable(vioTableName);
            Scan scan = new Scan();
            scan.addColumn("info".getBytes(), "fastDfsUrl1".getBytes());
            scan.addColumn("info".getBytes(), "fastDfsUrl2".getBytes());
            scan.addColumn("info".getBytes(), "fastDfsUrl3".getBytes());
            scan.addColumn("info".getBytes(), "fastDfsUrl4".getBytes());
            scan.addColumn("info".getBytes(), "fastDfsUrl5".getBytes());
            scan.addColumn("info".getBytes(), "fastDfsUrl6".getBytes());
            ResultScanner scanner = vioTable.getScanner(scan);
            for (Result result : scanner) {
                for (KeyValue value : result.raw()) {

                    fileService.deleteFile(new String(value.getValue()));

                    logger.info("删除图片+++++++" + new String(value.getValue()) + "----------" + new String(value.getQualifier()));
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }




    private static void putData(String hbaseFtpCol, String hbaseFastCol, String url, String ftpUrl, FileService fileService) {
        //存fastDfs
        params = new LinkedMultiValueMap<String, String>();
        params.add("urls", url);
        requestEntity = new HttpEntity<>(params, headers);
        ResponseEntity<PicByte> resp = restTemplate.exchange(ftpUrl, method, requestEntity, PicByte.class);
        Map<String, byte[]> map = resp.getBody().getMap();
        if (map != null && map.size() > 0) {
            for (Map.Entry<String, byte[]> entry : map.entrySet()) {
                if (url.startsWith("ftp") || url.startsWith("http")) {
                    String[] arr = url.split("/");
//                    logger.info("_-------------" + url);
                    String fastDfsUrl = fileService.uploadFile(entry.getValue(), arr[arr.length - 1].split("jpg")[0] + "jpg");
                    put.addColumn("info".getBytes(), hbaseFastCol.getBytes(), fastDfsUrl.getBytes());
                    put.addColumn("info".getBytes(), hbaseFtpCol.getBytes(), url.getBytes());
                    isPut = true;
                } else {
                    logger.info("图片其他存储方式:" + url);
                }

            }
        } else {
            logger.info("此ftp地址数据为空：==========================" + url);
        }
    }

}
