package com.hikcreate.service.fdfs.service.impl;

import com.github.tobato.fastdfs.service.FastFileStorageClient;
import com.hikcreate.service.fdfs.FastDFSClient;
import com.hikcreate.service.fdfs.service.FileService;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Resource;

/**
 * @author 赵东
 * @create 2019/3/22 13:45
 */
@Service("fileServiceImpl")
public class FileServiceImpl implements FileService {
    private static Logger logger = LoggerFactory.getLogger(FileServiceImpl.class);
    @Resource
    private FastDFSClient fastDFSClient;


    @Override
    public synchronized String uploadFile(byte[] file, String fileName) {
        try {
            Thread.sleep(70);
            //将文件上装到fast文件服务器上，成功则返回文件保存的路径
            String path = fastDFSClient.uploadFile(file, fileName);
            if (!StringUtils.hasText(path)) {
                logger.error("Upload Img Error");
            }
            logger.info("Upload Img Success. path {}", ("/group" + path.split("group")[1]));

            return "/group" + path.split("group")[1];
        } catch (Exception e) {
//            e.printStackTrace();
            logger.error("Upload Img Error, msg ={}", e);
            return uploadFile(file, fileName);
//            throw new RuntimeException("上传图片失败");
        }
    }

    @Override
    public byte[] downloadFile(String path) {
        return fastDFSClient.download(path);
    }

    @Override
    public void deleteFile(String path) {
        try {
            fastDFSClient.deleteFile(path);
        } catch (Exception e) {
            logger.info(e.toString());
        }
    }



}
