package com.hikcreate.utils.redis;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * @auther: lifuyi
 * @date: 2019/1/31 10:53
 * @description:
 */
@Component
public class RedisClientUtil {

    @Value("${redis.server}")
    private static String redisServer;

    @Autowired
    private static RedisClient redisClient;

    public static RedisClient getRedisClient() {

        if (redisClient == null) {
            synchronized (RedisClientUtil.class) {
                redisClient = RedisBuilder.getRedisClient(redisServer);
            }
        }
        return redisClient;
    }

}
